#!/usr/bin/perl

use strict;
use Image::Size;
use lib qw(.);
use imgtable;

my $tblscr=imgtable::tblscr;
my $imgscr=imgtable::imgscr;
my $prgroot=imgtable::prgroot;
my $httpcmd=imgtable::httpcmd;
my $httpopt=imgtable::httpopt;
my @imgext=imgtable::imgext;

print "Content-type: text/html; charset=UTF-8\n\n";
my ($prtname, $qrystr)=split(/\?/, $ENV{'REQUEST_URI'});
my ($name, $value, $zoom, $nomob, $mcnt, %param);
my @qryary=split('&', $qrystr) if($qrystr ne "");
$param{'zoom'}="pc" if($param{'zoom'} eq "sm");
foreach my $var (@qryary){
	($name, $value)=split('=', $var);
	$zoom=$var if($name eq "zoom");
	$nomob=$var if($name eq "nomob");
	$param{$name}=$value;
}
$prtname=~s/\/$//;
my $pathinf=$ENV{'PATH_INFO'};
my @finput=split(/\//, $ENV{'PATH_INFO'});
my $fname=$finput[$#finput];
my @tname=split(/\./, $fname);
my $type=$tname[$#tname];
my $titlename=$fname;
$titlename=~s/\.$type//;
my $mfile=$titlename.".csv";
my $netpath=$pathinf;
$netpath=~s/$fname/$mfile/;
my $dirpath=$ENV{'PATH_TRANSLATED'};
$dirpath=~s/$fname/$mfile/;
my (@url, @col, @alllist, @imglist, @memo);
if( -f "$dirpath"){
	open FILE, "$dirpath" or die;
	while(my $line=<FILE>){
		chomp($line);
		$line=~s/,/<BR>/g;
		$memo[$.]=$line;
	}
	close FILE;
}
my ($urlhead, $cmdall, $ret, $ref, $fx, $fy, $fchk, $cnum, $pname);
my ($fcnt, $hcnt, $icnt)=(0, 0, 0);
my $fpath=$dirpath;
$fpath=~s/$mfile//;
my $npath=$netpath;
$npath=~s/$mfile//;
if($param{'server_addr'} ne ""){
	$urlhead="http://".$param{'server_addr'}.$npath;
	$cmdall="$prgroot/$httpcmd $httpopt $urlhead";
	$ret=qx/$cmdall/;
	@url=split(/\n/, $ret);
	foreach my $fdmy (@url){
		chomp($fdmy);
		$fdmy=~s/\[\s{3}\]/\[BIN\]/;
		@col=split(/\s+/, $fdmy);
		$col[2]=~s/\[[0-9]+\]//g;
		if($ref eq "References" && $col[2]!~/\/?[A-Z]=[A-Z]$/){
			foreach my $ext (@imgext){
				if($col[2]=~/\.$ext$/i){
					$imglist[$hcnt]=$col[2];
					$imglist[$hcnt]=~s/$urlhead//;
					$hcnt++;
				}
			}
		}
		$ref=$col[0] if($col[0] eq "References");
	}
}
else{
	opendir LIST, "$fpath";
	@alllist=grep !/^\./, readdir LIST;
	closedir LIST;
	foreach my $file (sort(@alllist)){
		$fchk=$fpath."/".$file;
		($fx, $fy) = imgsize("$fchk");
		if( -f $fchk){
			if($fx!=0 && $fy!=0){
				$imglist[$fcnt]=$file;
				$fcnt++;
			}
		}
	}
}
$pname=$ENV{'REQUEST_URI'};
my $iname=$pname;
$iname=~s/$fname/$imglist[0]/;
my $lname=$pname;
$lname=~s/$fname/$imglist[$#imglist]/;
my $nname=$pname;
for($icnt=0; $icnt<=$#imglist; $icnt++){
	if($imglist[$icnt] eq $fname){
		$cnum=$icnt;
		$pname=~s/$fname/$imglist[$icnt-1]/ if($icnt!=0);
		$nname=~s/$fname/$imglist[$icnt+1]/ if($icnt!=$#imglist);
	}
}

if($param{'zoom'} eq "pc"){
	$param{'nomob'}=$param{'zoom'};
	$qrystr.="\&nomob=pc";
}

if($zoom ne "" && $param{'zoom'} ne "no"){
	$qrystr=~s/&$zoom//;
	$pname=~s/&$zoom//;
	$nname=~s/&$zoom//;
}

if($nomob ne "" && $param{'nomob'} eq "pc"){
	$qrystr=~s/&$nomob//;
	$pname=~s/&$nomob//;
	$nname=~s/&$nomob//;
}

if($param{'zoom'} eq ""){
	if($ENV{'HTTP_USER_AGENT'}=~/^Mozilla/){
		$param{'zoom'}="pc";
	}
	else{
		$param{'zoom'}="no";
		if($param{'maxsize'} eq ""){
			$param{'maxsize'}=307200;
			$qrystr.="&maxsize=";
			$qrystr.=$param{'maxsize'};
		}
	}
	$qrystr.="&zoom=";
	$qrystr.=$param{'zoom'};
}

if($param{'vwidth'} eq ""){
	if($param{'zoom'} eq "no"){
		$param{'vwidth'}=320;
	}
	else{
		$param{'vwidth'}=600;
	}
	$qrystr.="&vwidth=";
	$qrystr.=$param{'vwidth'};
}

my $imgscr=imgtable::imgscr;
my $scrpath=imgtable::scrpath($imgscr);
$scrpath.=imgtable::pathinfo;
my $maxwidth=$param{'vwidth'} if(defined $param{'vwidth'});
my ($x, $y) = imgsize("$ENV{'PATH_TRANSLATED'}");
my $fsize = -s "$ENV{'PATH_TRANSLATED'}";
my $width=$maxwidth;
if($x>=$y){
	$width=$x if($x<$maxwidth);
	$maxwidth++ if($x==$maxwidth || $param{'zoom'} eq "no");

}
else{
	$width=$y if($y<$maxwidth);
	$maxwidth++ if($y==$maxwidth || $param{'zoom'} eq "no");
}
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>$titlename Photo Image Viewer Page</TITLE>\n";
print "<meta name=\"viewport\" content=\"width=device-width, initial-scale=0.7\">\n";
print "</HEAD>\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#000000>\n";
print "<CENTER>\n";
print "<TABLE border=3 cellpadding=1 cellspacing=1>\n";
print "<TR><TH><A HREF=\"$prtname?$qrystr&zoom=yes\">印刷サイズの画像はこちら</A></TH></TR>\n" if($width==$maxwidth && $param{'zoom'} ne "yes");
if($fsize>$param{'maxsize'} && $param{'zoom'} eq "no"){
	print "<TR><TH>$fname<BR>";
	print "は携帯用画像ファイル<BR>";
	print "ではありません<BR>";
	print "PCのWebブラウザーで<BR>";
	print "閲覧して下さい</TH></TR>\n";
}
elsif($param{'server_addr'} ne ""){
	print "<TR><TH><FORM METHOD=GET ACTION=\"".$scrpath."\">\n";
	print "<SELECT name=nwidth>\n";
	print "<OPTION value=none";
	print " selected" if($param{'nwidth'} eq "none" || $param{'nwidth'} eq "");
	print ">none</OPTION>\n";
	print "<OPTION value=width";
	print " selected" if($param{'nwidth'} eq "width");
	print ">width</OPTION>\n";
	print "<OPTION value=height";
	print " selected" if($param{'nwidth'} eq "height");
	print ">height</OPTION>\n</SELECT>\n";
	foreach my $var (@qryary){
		($name, $value)=split('=', $var);
		print "<INPUT type=hidden name=$name value=$value>\n" if($name ne "nwidth");
	}
	print "<INPUT type=submit value=\"画像表示\">\n";
	print "</FORM></TH></TR>\n";
	print "<TR><TH><IMG SRC=\"http://$param{'server_addr'}$pathinf\"";
	print " $param{'nwidth'}=\"$param{'vwidth'}\"" if($param{'nwidth'} eq "width" || $param{'nwidth'} eq "height");
 	print "></TH></TR>\n";
}
elsif($param{'zoom'} eq "yes"){
	print "<TR><TH><IMG SRC=\"$pathinf\"></TH></TR>\n";
}
else{
	if($x>=$y){
		$width=$x if($x<$maxwidth);
		print "<TR><TH><IMG SRC=\"$pathinf\" width=\"$width\"></TH></TR>\n";
	}
	else{
		$width=$y if($y<$maxwidth);
		print "<TR><TH><IMG SRC=\"$pathinf\" height=\"$width\"></TH></TR>\n";
	}
}
if( -f "$dirpath" && $param{'zoom'} ne "yes"){
	print "<TR><TH>";
	for($mcnt=1; $mcnt<=$#memo; $mcnt++){
		print "$memo[$mcnt]";
		print "<P>" if($mcnt!=$#memo);
	}
	print "</TH></TR>\n";
}
print "</TABLE>\n";
print "<P>\n<HR>\n<P>\n";
$imgscr=~s/\.[a-z]+$//i;
$prtname=~s/$imgscr/$param{'ret'}/;
$prtname=~s/$fname//;
$prtname=~s/\/icons//;
$tblscr=~s/\.[a-z]+$//i;
$qrystr=~s/\&ret=$tblscr//;
if($param{'nomob'} eq "pc"){
	$qrystr=~s/\&nomob=pc//;
	$qrystr.="\&zoom=pc";
	$pname.="\&zoom=pc";
	$nname.="\&zoom=pc";
}
if($cnum>0){
	print "<A HREF=\"$iname\"><B>&brvbar;&lt;</B></A>";
	print "&emsp;";
	print "<A HREF=\"$pname\"><B>&lt;</B></A>";
	print "&emsp;";
}
print "<A HREF=\"$prtname?$qrystr\"><B>";
if($param{'zoom'} eq "no"){
	print "Go Back";
}
else{
	print "Return Current Directory";
}
print "</B></A>";
if($cnum<$#imglist){
	print "&emsp;";
	print "<A HREF=\"$nname\"><B>&gt;</B></A>";
	print "&emsp;";
	print "<A HREF=\"$lname\"><B>&gt;&brvbar;</B></A>";
}
print "\n</CENTER>\n";
print "</BODY>\n";
print "</HTML>\n";
exit 0;

