#!/usr/bin/perl

use strict;
use Image::Size;
use lib qw(.);
use imgtable;

print "Content-type: text/html\; charset=UTF-8\n\n";
print "<html>\n";
print "<head>\n";
print "<title>Image file list display</title>\n";
print "<meta name=\"viewport\" content=\"width=device-width, initial-scale=0.7\">\n";
print "</head>\n\n";

my $imgscr=imgtable::imgscr;
my $imgprg=$imgscr;
$imgprg=~s/\.[a-z]+$//i;
my $imglsscr=imgtable::imglsscr;
my $cgiprg=$imglsscr;
$cgiprg=~s/\.[a-z]+$//i;
my $prgroot=imgtable::prgroot;
my $httpcmd=imgtable::httpcmd;
my $httpopt=imgtable::httpopt;
my @imgext=imgtable::imgext;

my ($cgipath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$cgipath=~s/\/$//;
read (STDIN, $qrystr, $ENV{'CONTENT_LENGTH'}) if($qrystr eq "");
$qrystr="ret=$cgiprg" if($qrystr eq "");
my @qryary=split('&', $qrystr);
my (%param, $name, $value);
foreach my $var (@qryary){
	($name, $value) = split('=', $var);
	$param{$name}=$value;
	if($name eq "cgi"){
		$cgiprg = $value;
		$qrystr =~ s/$var//;
		$qrystr =~ s/^&//;
		$qrystr =~ s/&$//;
		$qrystr =~ s/&&/&/g;
	}
}
if($param{'ret'} eq ""){
	$qrystr.="&ret=";
	$qrystr.=$cgiprg;
}
else{
	$qrystr=~s/ret=[a-z0-9]+/ret=$cgiprg/i;
}
$cgipath=~s/$imglsscr/$cgiprg/ if($imglsscr!~/$cgiprg/);
$param{'zoom'}="pc" if($param{'zoom'} eq "sm");
if($param{'zoom'} eq ""){
	if($ENV{'HTTP_USER_AGENT'}=~/^Mozilla/){
		$param{'zoom'}="pc";
	}
	else{
		$param{'zoom'}="no";
	}
}

my $fpath = $ENV{'PATH_TRANSLATED'};
$fpath = $ENV{'DOCUMENT_ROOT'} if($ENV{'PATH_TRANSLATED'} eq "");
$fpath =~ s/index\.htm.*$//i;
$fpath =~ s/\/$//;
my $ifpath=$fpath;
if( -d "$ifpath/icons" && $param{'zoom'} eq "no"){
	$fpath.="/icons";
	$cgipath.="/icons";
}
my ($urlhead, $cmdall, $ret, $ref, @url, @col, @tlist, @udir);
my $cnt=0;
if($param{'server_addr'} ne ""){
	$urlhead = "http://".$param{'server_addr'}.$ENV{'PATH_INFO'};
	$cmdall="$prgroot/$httpcmd $httpopt $urlhead";
	$ret=qx/$cmdall/;
	@url=split(/\n/, $ret);
	foreach my $fdmy (@url){
		chomp($fdmy);
		$fdmy=~s/\[\s{3}\]/\[BIN\]/;
		@col=split(/\s+/, $fdmy);
		$col[2]=~s/\[[0-9]+\]//g;
		@udir=split(/\//, $col[2]);
		$col[2]=~s/$udir[2]/$param{'server_addr'}/ if($param{'server_addr'} ne "");
		if($ref eq "References" && $col[2]!~/\/?[A-Z]=[A-Z]$/){
			if($col[2]=~/\/$/){
				$tlist[$cnt]=$col[2];
				$cnt++;
			}
			foreach my $ext (@imgext){
				if($col[2]=~/\.$ext$/i){
					$tlist[$cnt]=$col[2];
					$cnt++;
				}
			}
		}
		$ref=$col[0] if($col[0] eq "References");
	}
}
else{
	opendir LIST, "$fpath";
	@tlist = grep !/^\.$/, readdir LIST;
	closedir LIST;
}

print "<body>\n";
print "<pre>\n";
print "<ul>\n";
my ($maxlen, $flen, $fstat, $fslen, $mfslen, $ix);
foreach my $fname (sort(@tlist)){
	$flen  =length($fname);
	$maxlen=$flen if($maxlen<$flen);
	$fstat =(stat "$fpath/$fname")[7];
	$fslen =length(sprintf("%d", $fstat/1024+0.5));
	$mfslen=$fslen if($mfslen<$fslen);
}
$mfslen=3 if($mfslen<3);
$mfslen++ if($mfslen<4);
my ($filename, $name, $value, $x, $y, $splen, $sfslen, $fsize, @fdate, @pinfo);
foreach my $fname (sort(@tlist)){
	$filename = $fname;
	if($param{'server_addr'} ne ""){
		$param{'http_host'}=$ENV{'HTTP_HOST'};
		if($ENV{'HTTP_HOST'}=~/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/){
			$param{'http_host'}=$ENV{'HTTP_X_FORWARDED_HOST'} if($ENV{'HTTP_X_FORWARDED_HOST'} ne "");
		}
		else{
			$param{'http_host'}=~s/\..*$// if($param{'server_addr'}!~/\./);
		}
		$filename=~s/$param{'server_addr'}/$param{'http_host'}/;
		$filename=~s/$ENV{'PATH_INFO'}/$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}/;
		$param{'path_info'}=$ENV{'PATH_INFO'};
		$param{'path_info'}=~s/\/$//;
		@pinfo=split(/\//, $param{'path_info'});
		$param{'path_info'}=~s/$pinfo[$#pinfo]//;
		if($param{'path_info'} eq "/" && $filename=~/$param{'http_host'}\/$/){
			$filename=~s/\/$//;
			$filename .= $ENV{'SCRIPT_NAME'};
			$filename .= $param{'path_info'};
		}
		$filename=~s/$param{'path_info'}$/$ENV{'SCRIPT_NAME'}$param{'path_info'}/ if($param{'path_info'} ne "/");
		$filename=~s/$imglsscr/$imgscr/ if($fname=~/\.[a-z0-9]{3}$/i);
		$filename .= "?$qrystr" if (defined $qrystr);
		print "<li><a href=\"$filename\">$fname</a>\n";
	}
	else{
	$flen=length($fname);
	$splen=$maxlen-$flen;
	$fstat = (stat "$fpath/$fname")[9];
	@fdate = split(" ", localtime($fstat));
	$fdate[2]=sprintf("%02d", $fdate[2]);
	$fstat = (stat "$fpath/$fname")[7];
	$fslen =length(sprintf("%d", $fstat/1024+0.5));
	$sfslen=$mfslen-$fslen-1;
	if( -d "$fpath/$fname" ){
		if($fname =~ /^\.\.$/){
			$filename .= "?$qrystr" if (defined $qrystr);
			print "<li><a href=\"$cgipath/$filename\">Parent Directory</a>\n" if($cgipath ne $ENV{'SCRIPT_NAME'});
		}
		else{
			$filename .= "?$qrystr" if (defined $qrystr);
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname ne "cgi-bin" && $fname ne "icons"){
				print "<li><a href=\"$cgipath/$filename\">", $fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a>";
				if($param{'zoom'} ne "no"){
					for($ix=0; $ix<=$splen; $ix++){
						print "&nbsp;";
					}
					$splen=$mfslen-5;
					for($ix=0; $ix<=$splen; $ix++){
						print "&nbsp;";
					}
					print "[DIR]&nbsp;";
					print $fdate[1]."-".$fdate[2]."-".$fdate[4]."&nbsp;".$fdate[3];
				}
				print "\n";
			}
		}
	}
	else{
		$fsize = sprintf("%d", $fstat/1024+0.5);
		($x, $y) = imgsize("$fpath/$fname");
		if($x>0 && $y>0 && -B "$fpath/$fname"){
			$cgipath =~ s/$cgiprg/$imgprg/;
			$filename .= "?$qrystr" if (defined $qrystr);
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname!~/^\.htaccess$/){
				print "<li><a href=\"$cgipath/$filename\">", $fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a>";
				if($param{'zoom'} eq "no"){
					print "<br>";
				}
				else{
					for($ix=0; $ix<=$splen; $ix++){
						print "&nbsp;";
					}
					for($ix=0; $ix<=$sfslen; $ix++){
						print "&nbsp;";
					}
				}
				print $fsize."k";
				print "&nbsp;".$fdate[1]."-".$fdate[2]."-".$fdate[4]."&nbsp;".$fdate[3] if($param{'zoom'} ne "no");
				print "&nbsp;";
				print $x."&times;".$y."\n";
			}
			$cgipath =~ s/$imgprg/$cgiprg/;
		}
	}
	}
}
print "</ul>\n";
print "</pre>\n";
if($ENV{'SERVER_SIGNATURE'} ne ""){
	print "<hr>\n";
	print "<br>\n";
	print $ENV{'SERVER_SIGNATURE'};
}
print "</body>\n";
print "</html>\n";

