#!/usr/bin/perl

use strict;
use lib qw(.);
use config;

my $authfile=config::authfile;
my $confile=config::confile;
my $outmin=config::outmin;
my $ulscr=config::ulscr;
my $unscr=config::unscr;
my $crynum=config::crynum;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<html>\n";
print "<head>\n";
print "<title>file list display</title>\n";
print "<meta name=\"viewport\" content=\"width=device-width, initial-scale=0.7\">";
print "</head>\n\n";
print "<body>\n";

my $mobile=1 if($ENV{'HTTP_USER_AGENT'}=~/^Mozilla/);
my $pathinfo=$ENV{'PATH_INFO'};
$pathinfo=~s/\/$//;

my ($cgipath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$cgipath =~ s/\/$//;
my @qryary=split('&', $qrystr);
my ($name, $value, %param);
foreach my $var (@qryary){
        ($name, $value)=split('=', $var);
        $param{$name}=$value;
}
my ($chkyear, $chkmon, $chkday, $chkhour, $chkmin, $pwchk);
my ($userid, $passwd, $luserid, $lpathinf, $intkey, $crypw);
my ($lyear, $lmon, $lmday, $lhour, $lmin, $lsec);
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)=localtime(time);
open CON, "$confile" or die;
if($param{'pwchk'}==1){
	while (my $line=<CON>){
		chomp($line);
		($luserid, $lpathinf, $lyear, $lmon, $lmday, $lhour, $lmin, $lsec)=split(':', $line);
		$chkyear=$year-$lyear;
		$chkmon=$mon-$lmon;
		$chkmon+=365*$chkyear if($chkyear>0);
		$chkday=$mday-$lmday;
		$chkday+=30*$chkmon if($chkmon>0);
		$chkhour=$hour-$lhour;
		$chkhour+=24*$chkday if($chkday>0);
		$chkmin=$min-$lmin;
		$chkmin+=60*$chkhour if($chkhour>0);
		if($chkmin==$outmin && $sec>$lsec){
			$pwchk=0;
		}
		else{
			$pwchk=1;
			$qrystr="pwchk=1";
		}
		$pwchk=0 if($chkmin>$outmin);
		$pwchk=1 if($pathinfo eq $lpathinf && $chkmin<$outmin*3);
		$pwchk=0 if($hour>$lhour);
		$pwchk=0 if($mday>$lmday);
		$pwchk=0 if($mon>$lmon);
		$pwchk=0 if($year>$lyear);
	}
}
close CON;

if($pwchk==0){
	read (STDIN, $qrystr, $ENV{'CONTENT_LENGTH'});
	@qryary=split('&', $qrystr);
	foreach my $var (@qryary){
		($name, $value)=split('=', $var);
		$param{$name}=$value;
	}
}

my @scrary=split(/\//, $ENV{'SCRIPT_NAME'});
my $scrfile=$scrary[$#scrary];

if($pwchk==0 && $param{'userid'} eq "" && $param{'passwd'} eq ""){
print "<FORM METHOD=POST ACTION=$cgipath>\n";
print "&nbsp;&nbsp;UserID:<input type=text name=userid";
print " value=$luserid" if($param{'pwchk'}==1);
print " size=20 maxlength=20 istyle=3>\n";
print "<p>\n";
print "Password:<input type=password name=passwd size=20 maxlength=20 istyle=3>\n";
print "<p>\n";
print "<input type=submit value=authorization>";
print "</FORM>\n";
}
else{
if( -f $authfile ){
	open CHK, "$authfile" or die;
	while (my $line=<CHK>){
		chomp($line);
		($userid, $passwd)=split(':', $line);
		if($param{'userid'} eq $userid && $pwchk==0){
			$intkey=substr($passwd, 0, $crynum);
			$crypw=crypt($param{'passwd'}, $intkey);
			if($passwd eq $crypw){
				$pwchk=1;
				$qrystr="pwchk=1";
			}
			else{
				print "<div align=center>\n";
				print "Password mismatch.<p>\n";
				print "<a href=\"$cgipath\">Return</a>\n";
				print "</div>\n";
				print "</body>\n";
				print "</html>\n";
				exit 1;
			}
		}
	}
	close CHK;
	if($pwchk==0){
		print "<div align=center>\n";
		print "No UserID.<p>\n";
		print "<a href=\"$cgipath\">Return</a>\n";
		print "</div>\n";
		print "</body>\n";
		print "</html>\n";
		exit 1;
	}
}
else{
	print "<div align=center>\n";
	print "No password file.<p>\n";
	print "<a href=\"$cgipath\">Return</a>\n";
	print "</div>\n";
	print "</body>\n";
	print "</html>\n";
	exit 1;
}
$luserid=$param{'userid'} if($param{'userid'} ne "");
open APP, "> $confile" or die;
flock APP, 2;
print APP $luserid.":".$pathinfo.":".$year.":".$mon.":".$mday.":".$hour.":".$min.":".$sec."\n";
flock APP, 8;
close APP;

my $fpath = $ENV{'PATH_TRANSLATED'};
$fpath = $ENV{'DOCUMENT_ROOT'} if($ENV{'PATH_TRANSLATED'} eq "");
$fpath =~ s/\/index\.htm.*$//i;
opendir LIST, "$fpath";
my @tlist = grep !/^\.$/, readdir LIST;
closedir LIST;
$fpath =~ s/\/$//;

$cgipath=~s/$scrfile/$unscr/;
print "<form action=\"$cgipath\" method=\"post\">\n";
$cgipath=~s/$unscr/$scrfile/;
print "<table>\n";
my ($maxlen, $flen, $splen, $ix);
foreach my $fname (sort(@tlist)){
	$flen=length($fname);
	$maxlen=$flen if($maxlen<$flen);
}
my ($pname, $fstat, $fsize, @fdate);
foreach my $fname (sort(@tlist)){
	$pname =$fname;
	$pname.="?".$qrystr if($qrystr ne "");
	$flen  =length($fname);
	$splen =$maxlen-$flen;
	$fstat =(stat "$fpath/$fname")[9];
	@fdate =split(" ", localtime($fstat));
	$fdate[2]=sprintf("%02d", $fdate[2]);
	$fstat =(stat "$fpath/$fname")[7];
	if( -d "$fpath/$fname" ){
		if($fname=~/^\.\.$/){
			if($cgipath ne $ENV{'SCRIPT_NAME'}){
				print "<tr><td><a href=\"$cgipath/$pname\">Parent Directory</a></td>";
				print "<td></td><td></td><td></td>" if($mobile==1);
				print "<td>rename</td><td>delete</td></tr>\n";
			}
		}
		else{
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname ne "cgi-bin"){
				print "<tr><td><a href=\"$cgipath/$pname\">".$fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a></td>";
			
				if($mobile==1){
					print "<td>";
					print $fdate[1]."-".$fdate[2]."-".$fdate[4]."</td><td>".$fdate[3]."</td><td>[DIR]</td>";
				}
				print "<td><input type=radio name=oname value=\"$fname\"></td>";
				print "<td><input type=checkbox name=rdname value=\"$fname\"></td></tr>\n";
			}
		}
	}
	else{
		$fsize=$fstat;
		$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
		if($fname!~/^\.ht[a-z]+$/){
			print "<tr><td><a href=\"$pathinfo/$fname\">".$fname;
			print "&#9;" if($fname=~/\W$/);
			print "</a></td>";
			if($mobile==1){
				print "<td>";
				print $fdate[1]."-".$fdate[2]."-".$fdate[4]."</td><td>".$fdate[3]."</td><td>".$fsize;
			}
			print "<td><input type=radio name=oname value=\"$fname\"></td>";
			print "<td><input type=checkbox name=rfname value=\"$fname\"></td></tr>\n";
		}
	}
}
print "</table>\n";
print "<br>\n";
print "rename&nbsp;&nbsp;<input type=text name=nname istyle=3><p>\n";
print "makedir&nbsp;<input type=text name=dname istyle=3><p>\n";
print "<input type=submit value=submit>\n";
print "</form>\n";
my $uagent=$ENV{'HTTP_USER_AGENT'};
$uagent=~s/\(//g;
$uagent=~s/\)$//;
$uagent=~s/\)\s/;\ /g;
$uagent=~s/(\/[0-9]+)\s/$1;\ /g;
my @acol=split(/;\s/, $uagent);
my $browser=shift(@acol);
my $msie=shift(@acol);
my $msos=shift(@acol);
my ($iename, $iever, $winname, $wintype, $winver, $ufchk);
if($browser eq "Mozilla/4.0 compatible"){
	($iename, $iever)=split(/\s/, $msie);
	($winname, $wintype, $winver)=split(/\s/, $msos);
	$ufchk=1 if($iever>7 && $winver>5);
}
else{
	$ufchk=1;
}
if($ufchk==1){
	$cgipath=~s/$scrfile/$ulscr/;
	print "<form action=\"$cgipath\" method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<input type=file name=upfile><p>\n";
	print "<input type=submit value=upload>\n";
	print "</form>\n";
	$cgipath=~s/$ulscr/$scrfile/;
}
}
print "<br>\n";
if($ENV{'SERVER_SIGNATURE'} ne ""){
	print "<hr>\n";
	print "<br>\n";
	print $ENV{'SERVER_SIGNATURE'};
}
print "</body>\n";
print "</html>\n";

