#!/usr/bin/perl

use strict;
use Image::Size;
use lib qw(.);
use imgtable;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Photo Image Table Page</TITLE>\n";
print "<meta name=\"viewport\" content=\"width=device-width, initial-scale=0.8\">\n";
print "</HEAD>\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#000000>\n";
print "<CENTER>\n";

if($ENV{'REQUEST_URI'} eq ""){
	print "REQUEST_URI environment variable is required.<p>\n";
	print "</CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";
	exit 1;
}
my $imgpscr=imgtable::imgpscr;
my $tblscr=imgtable::tblscr;
my %param=imgtable::paramget;
my ($imgpath, $qrystr)=split(/\?/, $ENV{'REQUEST_URI'});
$imgpath=~s/\/$//;
$param{'zoom'}="pc" if($param{'zoom'} eq "sm");
if($param{'zoom'} eq ""){
	if($ENV{'HTTP_USER_AGENT'}=~/^Mozilla/){
		$param{'zoom'}="pc";
		if($param{'maxsize'} eq ""){
			$param{'maxsize'}=0;
			$qrystr.="&maxsize=";
			$qrystr.=$param{'maxsize'};
		}
	}
	else{
		$param{'zoom'}="no";
		if($param{'maxsize'} eq ""){
			$param{'maxsize'}=307200;
			$qrystr.="&maxsize=";
			$qrystr.=$param{'maxsize'};
		}
	}
	$qrystr.="&zoom=";
	$qrystr.=$param{'zoom'};
}
if($param{'col'} eq ""){
	if($param{'zoom'} eq "no"){
		$param{'col'}=1;
	}
	else{
		$param{'col'}=4;
	}
	$qrystr.="&col=";
	$qrystr.=$param{'col'};
}
$param{'row'}=sprintf("%d", $param{'pfile'}/$param{'col'}) if($param{'pfile'} ne "");
if($param{'zoom'} eq "pc" && $param{'icon'} eq "yes"){
	$param{'icon'}="no";
	$qrystr=~s/icon=[a-z]+//;
	$qrystr=~s/&{2,}/&/;
	$qrystr=~s/^&//;
	$qrystr=~s/&$//;
}
$param{'icon'}="no" if($param{'icon'} eq "");
$param{'pnum'}=1 if($param{'pnum'} eq "");

if($ENV{'PATH_TRANSLATED'} eq ""){
	$imgpath=~s/$tblscr/$imgpscr/;
	$qrystr.="&ver=4";
	print "<A HREF=\"".$imgpath."?".$qrystr."\" TARGET=\"_top\">\n";
	print "PATH_TRANSLATED environment variable is required.</A><P>\n";
	print "</CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";
	exit 1;
}
my $INDATA=$ENV{'PATH_TRANSLATED'};
$INDATA=~s/\/index\.htm.*$//i;
$INDATA=~s/\/$//;
my $INIDATA=$INDATA;
if( -d "$INIDATA/icons" && $param{'zoom'} eq "no"){
	$param{'col'}=1;
	$param{'row'}=1;
	$param{'icon'}="yes";
	if($qrystr=~/icon=[a-z]+/){
		$qrystr=~s/icon=no/icon=yes/;
	}
	else{
		$qrystr.="&icon=yes";
	}
	$INDATA.="/icons";
}
opendir LIST, "$INDATA";
my @alllist=grep !/^\.$/, readdir LIST;
closedir LIST;

my $pathinfo=imgtable::pathinfo;
$pathinfo.="/icons" if( -d "$INIDATA/icons" && $param{'zoom'} eq "no");

$param{'pfile'}=$param{'col'}*$param{'row'};
my (%fsize, %pnum);
my ($x, $y, $chkdir, $psize, $maxpage) = (0, 0, 0, 0, 0, 1);
my ($ix, $iz, $ip, $iq) = (0, 0, 0, 0);
foreach my $fname (sort(@alllist)){
	if( -d "$INDATA/$fname" && $fname!~/^\.\.$/ && $fname!~/icons/ && $fname!~/cgi-bin/ && $param{'hidedir'} ne "yes" ){
       		$pnum{$fname} = 1;
		$chkdir = 1;
	}
}
$ix=1 if($chkdir==1);
foreach my $fname (sort(@alllist)){
	if( -B "$INDATA/$fname" ){
		if( -d "$INDATA/icons" && $param{'icon'} ne "no"){
			($x, $y) = imgsize("$INDATA/icons/$fname");
        		$fsize{$fname} = (stat "$INDATA/icons/$fname")[7] if($x>0);
		}
		else{
			($x, $y) = imgsize("$INDATA/$fname");
        		$fsize{$fname} = (stat "$INDATA/$fname")[7] if($x>0);
		}
	}
	$psize += $fsize{$fname} if($psize>0);
	if($iq==$param{'pfile'} && $param{'pfile'} ne "" && $fsize{$fname}>0){
		$ix++;
		$iq = 0;
                $psize = 0;
	}
        if($psize > $param{'maxsize'} && $param{'maxsize'} > 0 && $fsize{$fname} > 0){
                $ix++ if(($fsize{$fname}<=$param{'maxsize'} && $param{'zoom'} eq "no") || $param{'zoom'} ne "no");
                $psize = 0;
        }
        $psize += $fsize{$fname} if($psize==0);
	if($fsize{$fname}>0){
		if($fsize{$fname}>$param{'maxsize'} && $param{'zoom'} eq "no"){
       			$pnum{$fname} = 0;
		}
		else{
			if($chkdir==1){
				$ix++ if($ix==1 && $fname!~/^\.\.$/);
			}
			else{
				$ix++ if($ix==0 && $fname!~/^\.\.$/);
			}
			$pnum{$fname} = $ix;
			$ip++ if($pnum{$fname}==$param{'pnum'});
			$iq++;
		}
	}
	if($param{'maxsize'}==0 && $fsize{$fname}>0 && $param{'pfile'} eq ""){
		if($chkdir==1){
			$pnum{$fname} = 2;
		}
		else{
			$pnum{$fname} = 1;
		}
	}
}
$maxpage = $ix if($ix>$maxpage);
if($param{'width'} eq "" && $param{'zoom'} eq "no" && $ip==1){
	$param{'width'}=320;
	$qrystr.="&width=";
	$qrystr.=$param{'width'};
}

print "<TABLE border=3 cellpadding=1 cellspacing=1>\n";
($ix, $iz)=(0, -1);
($x, $y)=(0, 0);
my ($xx, $yy)=(0, 0);
my ($iconpath, $dname);
foreach my $fname (sort(@alllist)){
	print "<TR>\n" if(($ix%$param{'col'}==0) && ($iz!=$ix));
	$iz=$ix;
	$dname=$fname if($fname=~/^\.\.$/);
	if($pnum{$fname}==$param{'pnum'}){
	if( -d "$INDATA/$fname" ){
		$qrystr=~s/&pnum=[0-9]+//;
		print "<TH><A HREF=\"$imgpath/$fname?$qrystr\">$fname</A></TH>\n" if($fname!~/icons/ && $fname!~/cgi-bin/ && $fname!~/sound/i);
		$ix++ if($fname ne "icons" && $fname ne "cgi-bin" && $fname!~/sound/i);
	}
	else{
		($x, $y) = imgsize("$INDATA/$fname");
		if( $x>0 && $y>0 && -B "$INDATA/$fname" ){
			if( -d "$INIDATA/icons" ){
				if($pathinfo!~/\/icons/){
					$iconpath = $pathinfo."/icons";
				}
				else{
					$iconpath = $pathinfo;
				}
				($xx, $yy) = imgsize("$INIDATA/icons/$fname") if( -B "$INIDATA/icons/$fname" );
				if($param{'zoom'} eq "no"){
					if($xx>=$yy){
						if($param{'width'} eq ""){
							$qrystr.="&width=$xx";
						}
						else{
							$qrystr=~s/width=[0-9]+/width=$xx/;
						}
					}
					else{
						if($param{'width'} eq ""){
							$qrystr.="&width=$yy";
						}
						else{
							$qrystr=~s/width=[0-9]+/width=$yy/;
						}
					}
				}
				if($param{'icon'} eq "no" || ($xx==0 && $yy==0)){
						imgtable::prvprint($x, $y, $qrystr, $pathinfo, $imgpath, $fname);
						imgtable::memprint($param{'memo'}, $qrystr, $pathinfo, $imgpath, $fname);
				}
				else{
					imgtable::prvprint($xx, $yy, $qrystr, $iconpath, $imgpath, $fname);
					imgtable::memprint($param{'memo'}, $qrystr, $pathinfo, $imgpath, $fname);
				}
			}
			else{
				imgtable::prvprint($x, $y, $qrystr, $pathinfo, $imgpath, $fname);
				imgtable::memprint($param{'memo'}, $qrystr, $pathinfo, $imgpath, $fname);
			}
			$ix++ if($fname ne "icons" && $fname ne "cgi-bin");
		}
	}
	}
	else{
		$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
		if( -f "$INDATA/$fname" && $pnum{$fname}==0){
			if($param{'pnum'}==1 && $param{'hidefile'} eq "no" && $fname!~/\.csv$/){
				print "<TH>$fname</TH>\n";
				$ix++ if($fname ne "icons" && $fname ne "cgi-bin");
			}
			if($ip==0 && $param{'hidefile'} ne "no"){
				if($param{'pnum'}>1 || ($param{'pnum'}==1 && $chkdir==0)){
					($x, $y) = imgsize("$INDATA/$fname");
					if($x>0 && $y>0){
					print "<TH>$fname<BR>は表示出来ません</TH>\n";
					$ix++ if($fname ne "icons" && $fname ne "cgi-bin");
					}
					$maxpage=$param{'pnum'};
				}
			}
		}
	}
	print "</TR>\n" if(($ix%$param{'col'}==0) && ($iz!=$ix));
}
print "</TR>\n" if($ix%$param{'col'}!=0 || ($iz-$ix==0 && $param{'col'}==1));
print "<TH>ファイルがありません</TH>\n</TR>\n" if($ix==0);
print "</TABLE>\n";
print "<P>\n<HR>\n<P>\n";
$qrystr=~s/&pnum=[0-9]+//;
$qrystr=~s/&width=[0-9]+// if($param{'zoom'} eq "no" && $ip==1);
if($param{'pnum'}>1 && ($ip>0 || $chkdir>0)){
	print "<A HREF=\"$imgpath?$qrystr&pnum=1\"><B>&brvbar;&lt;</B></A>";
	print "&emsp;";
	$param{'pnum'}--;
	print "<A HREF=\"$imgpath?$qrystr&pnum=$param{'pnum'}\"><B>&lt;</B></A>";
	print "&emsp;";
	$param{'pnum'}++;
}
if ($dname ne ""){
	if($param{'hidedir'} eq "yes"){
		print "<FONT COLOR=#0000FF><U>";
	}
	else{
		if($ENV{'PATH_INFO'} eq "\/"){
			$imgpath=~s/$tblscr/$imgpscr/;
			$qrystr.="&ver=4";
			print "<A HREF=\"".$imgpath."?".$qrystr."\" TARGET=\"_top\">";
			$imgpath=~s/$imgpscr/$tblscr/;
		}
		else{
			print "<A HREF=\"$imgpath/$dname?$qrystr\">";
		}
	}
	print "<B>";
	if($param{'zoom'} eq "no"){
		print "Go Back";
	}
	else{
		print "Go to Parent Directory";
	}
	print "</B>";
	if($param{'hidedir'} eq "yes"){
		print "</U></FONT>";
	}
	else{
		print "</A>";
	}
	$imgpath=~s/$imgpscr/$tblscr/ if($ENV{'PATH_INFO'} eq "\/");
}
if($param{'pnum'}<$maxpage && ($ip>0 || $chkdir>0)){
	$param{'pnum'}++;
	print "&emsp;";
	print "<A HREF=\"$imgpath?$qrystr&pnum=$param{'pnum'}\"><B>&gt;</B></A>";
	$param{'pnum'}--;
	print "&emsp;";
	print "<A HREF=\"$imgpath?$qrystr&pnum=$maxpage\"><B>&gt;&brvbar;</B></A>";
}
print "\n</CENTER>\n";
print "</BODY>\n";
print "</HTML>\n";
exit 0;

